(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */

	function hexToRgb(hex) {
	  	var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
	  	return result ? {
	    	r: parseInt(result[1], 16),
	    	g: parseInt(result[2], 16),
	    	b: parseInt(result[3], 16)
	  	} : null;
	}

	$(document).ready(function() {
	    var table = $('#mt_woocommerce_fake_variations').DataTable({
  			"columnDefs": [
    			{ "orderable": false, "targets": [4,5] }

  			]
	    });

    	$('#mt_woocommerce_fake_variations_wrapper tbody').on('click', 'button[name="edit-fake-variation"]', function(){
    		var row = $(this).parents().eq(2);
    		var data = table.row( row ).data();
    		// var html = $.parseHTML(data[5]);
    		console.log(data);
    		var product_id = $(this).parents().eq(2).find('td:first-child span').attr('product_id');
	    	var attribute_name = $(this).parents().eq(2).find('td:nth-child(2)').text();
	    	var fake_variation_product_id = $(this).parents().eq(2).find('td:nth-child(3) span').attr('fake_variation_product_id');
	    	var fake_variation_product_display_name = $(this).parents().eq(2).find('td:nth-child(4)').text().trim();
	    	var fake_variation_status = $(this).parents().eq(2).find('input[name="variation_status"]').val();
	    	var fake_variation_type = data[4];
	    	var fake_variation_image = $(this).parents().eq(2).find('input[name="variation_img"]').val();
	    	var fake_variation_color = $(this).parents().eq(2).find('input[name="variation_color"]').val();
	    	var fake_variation_id = $(this).val();
	    	console.log("fake_variation_type: "+fake_variation_type);


    		$('form.edit_fake_variation #mt_wfvl_edit_product_id').val(product_id).trigger('change');
    		$('form.edit_fake_variation #mt_wfvl_edit_fake_variation').val(fake_variation_product_id).trigger('change');
    		$('form.edit_fake_variation input[name="mt_wfvl_edit_attribute_name"]').val(attribute_name.trim());
    		$('form.edit_fake_variation input[name="mt_wfvl_edit_fake_variation_name"]').val(fake_variation_product_display_name.trim());

    		if(fake_variation_status.trim() == 'active') {
    			$('form.edit_fake_variation input[name="mt_wfvl_edit_fake_variation_inactive"]').prop( "checked", false );
    		}else if(fake_variation_status.trim() == 'inactive') {
    			$('form.edit_fake_variation input[name="mt_wfvl_edit_fake_variation_inactive"]').prop( "checked", true );
    		}

    		if(fake_variation_type.trim() == 'image') {
    			$('#mt_wfvl_edit_fake_variation_type').val('image').trigger('change');
    			$('#mt_wfvl_edit_fake_variation_image').val(fake_variation_image.trim());

    		} else if (fake_variation_type.trim() == 'color') {
    			$('#mt_wfvl_edit_fake_variation_type').val('color').trigger('change');
    			$('#mt_wfvl_edit_fake_variation_color').val(fake_variation_color.trim());
    			$('.button.wp-color-result').attr('style', 'background-color: rgb('+hexToRgb(fake_variation_color.trim()).r+','+hexToRgb(fake_variation_color.trim()).g+','+hexToRgb(fake_variation_color.trim()).b+')');
    		} else {
    			$('#mt_wfvl_edit_fake_variation_type').val('text').trigger('change');
    		}
    		$('form.edit_fake_variation input[name="variation_id"]').val(fake_variation_id);

    	})

		// Uploading media files
		var file_frame;
		var wp_media_post_id = wp.media.model.settings.post.id; // Store the old id
		var set_to_post_id = ''; // Set this

		jQuery('.upload_image_button').on('click', function( event ){

			event.preventDefault();

			// Create the media frame.
			file_frame = wp.media.frames.file_frame = wp.media({
				title: 'Select a image to upload',
				button: {
					text: 'Use this image',
				},
				multiple: false	// Set to true to allow multiple files to be selected
			});

			// When an image is selected, run a callback.
			file_frame.on( 'select', function() {
				// We set multiple to false so only get one image from the uploader
				var attachment = file_frame.state().get('selection').first().toJSON();

				// Do something with attachment.id and/or attachment.url here
				$( '.image-preview' ).attr( 'src', attachment.url ).css( 'width', 'auto' );
				$( '.image-preview' ).parent().show();
				$( '#mt_wfvl_fake_variation_image' ).val( attachment.id );
				$( '#mt_wfvl_edit_fake_variation_image' ).val( attachment.id );

				// Restore the main post ID
				wp.media.model.settings.post.id = wp_media_post_id;
			});

				// Finally, open the modal
				file_frame.open();
		});

		// Restore the main ID when the add media button is pressed
		jQuery( 'a.add_media' ).on( 'click', function() {
			wp.media.model.settings.post.id = wp_media_post_id;
		});

		if ($('.image-preview').attr('src') == "") {
			$('.image-preview').parent().hide();
		}

		var myOptions = {
		    // you can declare a default color here,
		    // or in the data-default-color attribute on the input
		    defaultColor: false,
		    // a callback to fire whenever the color changes to a valid color
		    change: function(event, ui){},
		    // a callback to fire when the input is emptied or an invalid color
		    clear: function() {},
		    // hide the color picker controls on load
		    hide: true,
		    // show a group of common colors beneath the square
		    // or, supply an array of colors to customize further
		    palettes: true
		};
		 
		$('.my-color-field').wpColorPicker(myOptions);


		$('#mt_wfvl_fake_variation_type').on('change', function(){
			if(this.value == 'image') {
				$('#mt_wfvl_fake_variation_image').parents().eq(1).removeClass('hidden');
				$('#mt_wfvl_fake_variation_color').parents().eq(4).addClass('hidden');
			} else if(this.value == 'color') {
				$('#mt_wfvl_fake_variation_image').parents().eq(1).addClass('hidden');
				$('#mt_wfvl_fake_variation_color').parents().eq(4).removeClass('hidden');
			} else if(this.value == 'text') {
				$('#mt_wfvl_fake_variation_image').parents().eq(1).addClass('hidden');
				$('#mt_wfvl_fake_variation_color').parents().eq(4).addClass('hidden');
			}
		})

		$('#mt_wfvl_edit_fake_variation_type').on('change', function(){
			if(this.value == 'image') {
				$('#mt_wfvl_edit_fake_variation_image').parents().eq(1).removeClass('hidden');
				$('#mt_wfvl_edit_fake_variation_color').parents().eq(4).addClass('hidden');
			} else if(this.value == 'color') {
				$('#mt_wfvl_edit_fake_variation_image').parents().eq(1).addClass('hidden');
				$('#mt_wfvl_edit_fake_variation_color').parents().eq(4).removeClass('hidden');
			} else if(this.value == 'text') {
				$('#mt_wfvl_edit_fake_variation_image').parents().eq(1).addClass('hidden');
				$('#mt_wfvl_edit_fake_variation_color').parents().eq(4).addClass('hidden');
			}
		});

		// $('#mt_wfvl_product_id').select2();
		// $('#mt_wfvl_fake_variation').select2();

    	jQuery('#mt_wfvl_product_id').select2({
            ajax: {
                url: ajaxurl, // AJAX URL is predefined in WordPress admin
                dataType: 'json',
                delay: 250, // delay in ms while typing when to perform a AJAX search
                data: function (params) {
                    return {
                        q: params.term, // search query
                        action: 'mtAjaxSearchTitleSku' // AJAX action for admin-ajax.php
                    };
                },
                processResults: function( data ) {
                    var options = [];
                    if ( data ) {
     
                        // data is the array of arrays, and each of them contains ID and the Label of the option
                        $.each( data, function( index, text ) { // do not forget that "index" is just auto incremented value
                            options.push( 
                                { 
                                    id: text[0], 
                                    text: text[1]  
                                } 
                            );
                        });
     
                    }
                    return {
                        results: options
                    };
                },
                cache: true
            },
            minimumInputLength: 3 // the minimum of symbols to input before perform a search
        });
    	jQuery('#mt_wfvl_fake_variation').select2({
            ajax: {
                url: ajaxurl, // AJAX URL is predefined in WordPress admin
                dataType: 'json',
                delay: 250, // delay in ms while typing when to perform a AJAX search
                data: function (params) {
                    return {
                        q: params.term, // search query
                        action: 'mtAjaxSearchTitleSku' // AJAX action for admin-ajax.php
                    };
                },
                processResults: function( data ) {
                    var options = [];
                    if ( data ) {
     
                        // data is the array of arrays, and each of them contains ID and the Label of the option
                        $.each( data, function( index, text ) { // do not forget that "index" is just auto incremented value
                            options.push( 
                                { 
                                    id: text[0], 
                                    text: text[1]  
                                } 
                            );
                        });
     
                    }
                    return {
                        results: options
                    };
                },
                cache: true
            },
            minimumInputLength: 3 // the minimum of symbols to input before perform a search
        });


	});

})( jQuery );
