<?php

/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       http://modeltheme.com/
 * @since      1.0.0
 *
 * @package    Mt_Wfvl_Woocommerce_Fake_Variation_Links
 * @subpackage Mt_Wfvl_Woocommerce_Fake_Variation_Links/includes
 */

/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @since      1.0.0
 * @package    Mt_Wfvl_Woocommerce_Fake_Variation_Links
 * @subpackage Mt_Wfvl_Woocommerce_Fake_Variation_Links/includes
 * @author     ModelTheme <support@modeltheme.com>
 */
class Mt_Wfvl_Woocommerce_Fake_Variation_Links_i18n {


	/**
	 * Load the plugin text domain for translation.
	 *
	 * @since    1.0.0
	 */
	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'mt-woocommerce-fake-variation-links',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

	}



}
